Index: /trunk/SophyaPI/PIext/nobjmgr.h
===================================================================
--- /trunk/SophyaPI/PIext/nobjmgr.h	(revision 332)
+++ /trunk/SophyaPI/PIext/nobjmgr.h	(revision 333)
@@ -32,7 +32,10 @@
 
 // Gestion des repertoires
-  virtual void		CreateDir(string const& dirname);
-  virtual void		DeleteDir(string const& dirname);
-  virtual void		SetCurrentDir(string const& dirname);
+  virtual void		CreateDir(string & dirname);
+  virtual void		DeleteDir(string & dirname);
+  virtual void		SetCurrentDir(string & dirname);
+  virtual void		GetCurrentDir(string & dirname);
+  virtual void		ListDirs(string & patt);
+  virtual void		GetDirList(string & patt, vector<string>& );
   virtual void		CleanTmpDir();
   virtual void		CleanOldDir();
@@ -53,5 +56,6 @@
   virtual void		ReadAll(string const & nomppf);
   virtual void		ReadFits(string const & flnm, string & nobj);
-  virtual void          SaveObj(string & nom, POutPersist& s);
+  virtual void          SaveObj(string & nom, POutPersist& s, bool keeppath=false);
+  virtual void          SaveObjects(string & patt, string const& nomppf);
   virtual void          SaveAll(string const& nomppf);
   virtual void          SaveFits(string & nom, string const & flnm);
@@ -65,35 +69,14 @@
   virtual void          DisplaySurf3D(string & nom, string dopt="");
   virtual void          DisplayNT(string & nom, string& nmx, string& nmy, string& nmz,  
-                                  string& erx, string& ery, string& erz, string dopt="");
-  virtual void          DisplayGFD(string & nom, string& numvarx, string& numvary, string& err, string dopt="");
+                                  string& erx, string& ery, string& erz, 
+                                  string dopt="", bool fg3d=false);
+  virtual void          DisplayGFD(string & nom, string& numvarx, string& numvary, 
+                                   string& err, string dopt="");
 
   virtual void		SetGraphicAttributes(string gratt="");
   virtual void		SetGraphicWinZone(int nzx, int nzy, bool fcr=false);
 
-
-//  Trace d'expression de NTuple, et d'autres objets
-  virtual void          DisplayPoints2D(string & nom, string& expx, string& expy,
-                                        string& experrx, string& experry, 
-                                        string& expcut, string dopt="");
-  virtual void          DisplayPoints3D(string & nom, string& expx, string& expy, string& expz, 
-                                        string& expcut, string dopt="");
-//  Projection d'expressions dans histogramme (et trace) 
-  virtual void          ProjectH1(string & nom, string& expx, string& expwt, string& expcut, 
-                                  string& nomh1, string dopt="");
-  virtual void          ProjectH2(string & nom, string& expx, string& expy, string& expwt, 
-                                  string& expcut, string& nomh2, string dopt="");
-  virtual void          ProjectHProf(string & nom, string& expx, string& expy, string& expwt, 
-                                  string& expcut, string& nomprof, string dopt="");
-//  Projection d'expression dans vecteurs et dans n-tuple
-  virtual void          FillVect(string & nom, string& expx, string& expcut, 
-                                 string& nomvec, string dopt="");
-  virtual void          FillNT(string & nom, string& expx, string& expy, string& expz,
-                               string& expt, string& expcut, string& nomnt); 
-  virtual void          FillGFD(string & nom, string& expx, string& expy, string& expz,
-                               string& experr, string& expcut, string& nomgfd);
-
-//   Methodes de fit, a rajouter  (pour CMV , deux methodes H1 H2 ou 1 seule ??) ...
-  virtual void          Fit12D(string & nom, string& func,
-                              string par,string step,string min,string max,string opt);
+// Acces a l'adaptateur
+  virtual NObjMgrAdapter*	GetObjAdapter(string & nom);
 
 // Acces au PIApplication et a la classe de service 
@@ -101,6 +84,7 @@
   virtual Services2NObjMgr* 	GetServiceObj();
 
-protected :
-  virtual NObjMgrAdapter*	GetObjAdapter(string & nom);
+  virtual void		AddWRsId(string & nom, int wrsid);
+// Pour utilisation par ObjMgrWind
+  virtual void		UpdateObjMgrWindow(int did);
 };
 
Index: /trunk/SophyaPI/PIext/piacmd.cc
===================================================================
--- /trunk/SophyaPI/PIext/piacmd.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/piacmd.cc	(revision 333)
@@ -141,5 +141,7 @@
 usage += "  set unset listvar listcommands exec shell \n";
 usage += "  > set varname 'string'   # To set a variable, $varname \n";
+usage += "  > setol varname patt     # Fills varname with object list \n";
 usage += "  > unset varname          # clear variable definition \n";
+usage += "  > echo string            # output string \n";
 usage += "  > listvars   # List of variable names and values \n";
 usage += "  > listcommands # List of all known commands \n";
@@ -282,5 +284,5 @@
 int PIACmd::Interpret(string& s)
 {
-
+int rc = 0;
 cmdtok tokens;
 if (s.length() < 1)  return(0);
@@ -334,5 +336,15 @@
 else if (kw == "set") {
   if (tokens.size() < 2) { cout << "PIACmd::Interpret() Usage: set varname string" << endl;  return(0); }
-  mVars[tokens[0]] = tokens[1];
+  string xx = "";
+  for (int kk=0; kk<tokens.size(); kk++)  xx += (tokens[kk] + ' ');
+  mVars[tokens[0]] = xx;
+  }
+else if (kw == "setol") {
+  if (tokens.size() < 2) { cout << "PIACmd::Interpret() Usage: setol varname objnamepattern" << endl;  return(0); }
+  vector<string> ol;
+  mObjMgr->GetObjList(tokens[1], ol); 
+  string vol = ""; 
+  for (int kk=0; kk<ol.size(); kk++)  vol += (ol[kk] + ' ');
+  mVars[tokens[0]] = vol;
   }
 else if (kw == "unset") {
@@ -341,4 +353,8 @@
   if (it != mVars.end())  mVars.erase(it);
   else cerr << "PIACmd::Interpret() No variable with name " << tokens[0] << endl;
+  }
+else if (kw == "echo") {
+  for (int kk=0; kk<tokens.size(); kk++)  cout << tokens[kk] << " " ;
+  cout << endl;
   }
 else if (kw == "listvars") {
@@ -379,17 +395,51 @@
   }
 //  Execution d'une commande enregistree
-else {
-  CmdExmap::iterator it = cmdexmap.find(kw);
-  if (it == cmdexmap.end())  cout << "No such command : " << kw << " ! " << endl;
+else rc = ExecuteCommand(kw, tokens);
+
+if (timing)  gltimer->Split();
+return(rc);
+}
+
+/* --Methode-- */
+int PIACmd::ExecuteCommandLine(string& line)
+{
+cmdtok tokens;
+if (line.length() < 1)  return(0);
+
+string toks,kw;
+size_t p = line.find_first_not_of(" ");
+line = line.substr(p);
+p = 0;
+size_t q = line.find_first_of(" ");
+size_t l = line.length();
+
+if (q < l)
+  {  kw = line.substr(p,q-p);  toks = line.substr(q, l-q); }
+else { kw = line.substr(p,l-p);  toks = ""; }
+
+q = 0;
+while (q < l)  {
+  p = toks.find_first_not_of(" ",q+1); // au debut d'un token
+  if (p>=l) break;
+  q = toks.find_first_of(" ",p); // la fin du token;
+  string token = toks.substr(p,q-p);
+  tokens.push_back(token);
+  }
+
+return(ExecuteCommand(kw, tokens));  
+}
+
+/* --Methode-- */
+int PIACmd::ExecuteCommand(string& keyw, vector<string>& args)
+{
+  int rc = -1;
+  CmdExmap::iterator it = cmdexmap.find(keyw);
+  if (it == cmdexmap.end())  cout << "No such command : " << keyw << " ! " << endl;
   else { 
-    if ((*it).second.cex) (*it).second.cex->Execute(kw, tokens);
-    else cout << "Dont know how to execute " << kw << " ? " << endl;
+    if ((*it).second.cex) rc = (*it).second.cex->Execute(keyw, args);
+    else cout << "Dont know how to execute " << keyw << " ? " << endl;
     }
-  }
-
-if (timing)  gltimer->Split();
-return(0);
-}
-
+  return(rc);
+}
 
 /* --Methode-- */
Index: /trunk/SophyaPI/PIext/piacmd.h
===================================================================
--- /trunk/SophyaPI/PIext/piacmd.h	(revision 332)
+++ /trunk/SophyaPI/PIext/piacmd.h	(revision 333)
@@ -72,4 +72,6 @@
 
   virtual int		Interpret(string& line);
+  virtual int		ExecuteCommandLine(string& line);
+  virtual int		ExecuteCommand(string& keyw, vector<string>& args);
   virtual int		ExecFile(string& file);
 
Index: /trunk/SophyaPI/PIext/pintup3d.cc
===================================================================
--- /trunk/SophyaPI/PIext/pintup3d.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/pintup3d.cc	(revision 333)
@@ -23,5 +23,4 @@
 string name;
 if (mNT == NULL)  xK = yK = zK = -1;
-if (mNT == NULL)  xK = yK = -1;
 if (px == NULL) xK = -1;
 else { name = px; xK = mNT->ColumnIndex(name); }
Index: /trunk/SophyaPI/PIext/pintuple.cc
===================================================================
--- /trunk/SophyaPI/PIext/pintuple.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/pintuple.cc	(revision 333)
@@ -27,4 +27,15 @@
 if (py == NULL) yK = -1;
 else { name = py; yK = mNT->ColumnIndex(name); }
+}
+
+/* --Methode-- */
+void  PINTuple::SelectWt(const char* pw, int nbins)
+{
+nWbins = (nbins > 0) ? nbins : 10;
+if (pw == NULL) wK = -1;  
+else { string name = pw;   wK = mNT->ColumnIndex(name);  }
+ 
+if (wK >= 0) mNT->GetMinMax(wK, wMin, wMax);
+else  { wMin = 0.; wMax = 1.; }
 }
 
@@ -67,5 +78,5 @@
 void PINTuple::Draw(PIGraphicUC* g, double xmin, double ymin, double xmax, double ymax)
 {
-double xp,yp,xer,yer;
+double xp,yp,xer,yer,wp;
 double xl,yl;
 int nok;
@@ -74,4 +85,16 @@
 if ( (xK < 0) || (yK < 0) )  return;
 if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+
+//  Pour tracer des markers avec taille fonction de Wt (poids)
+double dw = (wMax-wMin)/nWbins;
+if (dw < 1.e-19) dw = 1.e19;
+int msz,sz;
+
+PIMarker mrk;
+if (wK >= 0)  mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_CircleMarker;
+else   mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_DotMarker;
+msz = mMSz;
+if (msz < 1) msz = 1;
+g->SelMarker(sz, mrk);
 
 nok = 0;  
@@ -93,4 +116,13 @@
     if(yer>0.) g->DrawLine(xp, yp-yer, xp, yp+yer);
   }
+  if (wK >= 0) { // Taille de marker en fonction du poids
+    wp = mNT->GetCell(i, wK);
+    sz = (int)((wp-wMin)/dw);
+    if (sz < 0) sz = 0;
+    if (sz > nWbins)  sz = nWbins;
+    sz += msz;
+    if (sz < 2)  g->SelMarker(sz, PI_DotMarker);
+    else g->SelMarker(sz, mrk);
+  }
   g->DrawMarker(xp, yp); 
 }
Index: /trunk/SophyaPI/PIext/pintuple.h
===================================================================
--- /trunk/SophyaPI/PIext/pintuple.h	(revision 332)
+++ /trunk/SophyaPI/PIext/pintuple.h	(revision 333)
@@ -14,4 +14,5 @@
   
           void       SelectXY(const char* px, const char* py);
+          void       SelectWt(const char* pw=NULL, int nbins=10);
           void       SelectErrBar(const char* erbx=NULL, const char* erby=NULL);
 
@@ -22,4 +23,7 @@
   int xK, yK;          // Index du nom de variable en X/Y ds le ntuple
   int xebK, yebK;      // Index du nom de variable en ErrBarX/Y ds le ntuple
+  int wK;              // Index du nom de variable poids
+  double wMin, wMax;        // Valeurs de poids min/max
+  int nWbins;               // Nombre de bins pour le poids (Wt)
 
 };
Index: /trunk/SophyaPI/PIext/pisiadw.cc
===================================================================
--- /trunk/SophyaPI/PIext/pisiadw.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/pisiadw.cc	(revision 333)
@@ -34,18 +34,21 @@
 // On definit la taille a partir de la taille par defaut des composantes 
 PIApplicationPrefCompSize(bsx, bsy);
-spx = bsx/4;   spy = bsy/3;
-tsx = 5*bsx+6*spx;  tsy = 7*bsy+4*spy;
+spx = bsx/4;   spy = bsy/4;
+tsx = 4.0*bsx+3*spx;  tsy = 6*bsy+7*spy;
 SetSize(tsx,tsy);
-objlist = new PIList(this, "objlist", tsx-spx, tsy-4*spy-bsy, spx/2, spy/2);
+dirlist = new PIOptMenu(this, "dirlist", 2.5*bsx, bsy, spx+0.25*bsx, spy); 
+dirlist->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
+objlist = new PIList(this, "objlist", 3*bsx, tsy-3*spy-bsy, spx, 2*spy+bsy);
 objlist->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
-objlist->SetBorderWidth(2);
-
-int py = tsy-2*spy-bsy;
-int px = spx;
-mBut[0] = new PIButton(this, "Display", 100, bsx, bsy, px, py);   px += (bsx+spx);
-mBut[1] = new PIButton(this, "Print",   200, bsx, bsy, px, py);   px += (bsx+spx);
-mBut[2] = new PIButton(this, "SavePPF", 300, bsx, bsy, px, py);   px += (bsx+spx);
-mBut[3] = new PIButton(this, "Delete",  400, bsx, bsy, px, py);   px += (bsx+spx);
-mBut[4] = new PIButton(this, "Dismiss", 900, bsx, bsy, px, py);   px += (bsx+spx);
+// objlist->SetBorderWidth(2);
+
+int py = spy;
+int px = 2*spx+3*bsx;
+mBut[0] = new PIButton(this, "SetCurDir", 20, bsx, bsy, px, py);   py += (bsy+spy);
+mBut[1] = new PIButton(this, "Display", 20, bsx, bsy, px, py);   py += (bsy+spy);
+mBut[2] = new PIButton(this, "Print",   30, bsx, bsy, px, py);   py += (bsy+spy);
+mBut[3] = new PIButton(this, "SavePPF", 40, bsx, bsy, px, py);   py += (bsy+spy);
+mBut[4] = new PIButton(this, "Delete",  50, bsx, bsy, px, py);   py += (bsy+spy);
+mBut[5] = new PIButton(this, "Dismiss", 90, bsx, bsy, px, py);   py += (bsy+spy);
 
 for(i=0; i<5; i++)
@@ -59,6 +62,7 @@
 {
 int i;
+delete dirlist;
 delete objlist;
-for(i=0; i<5; i++)  delete mBut[i];
+for(i=0; i<6; i++)  delete mBut[i];
 }
 
@@ -67,4 +71,9 @@
 {
 dap->SetBlocked();
+string cdir;
+dap->ObjMgr()->GetCurrentDir(cdir);
+cdir = '/' + cdir;
+dirlist->SetValueStr(cdir);
+dap->ObjMgr()->UpdateObjMgrWindow(dirlist->GetValue()-30000);
 PIWindow::Show();
 return;
@@ -77,12 +86,21 @@
   // PIMessage ssg = ModMsg(msg);
 msg = UserMsg(msg);
-if (msg == 900)  {
+if (msg == 90)  {
   dap->SetReady();
   this->Hide();
   return;
-}
+  }
+else if (msg >= 30000) {
+  dap->ObjMgr()->UpdateObjMgrWindow(msg-30000);
+  return;
+  }
+else if (msg == 10) {
+  string cdir = dirlist->GetValueStr();
+  dap->ObjMgr()->SetCurrentDir(cdir);
+  return;
+  }
 
 string nom = "";
-if ( (msg == 100) || (msg == 200) || (msg == 300) || (msg == 400) ) {
+if ( (msg == 20) || (msg == 30) || (msg == 40) || (msg == 50) ) {
   string sel = objlist->GetSelectionStr();
   //  size_t p = sel.find_first_not_of(" \t");
@@ -91,29 +109,26 @@
   size_t q = sel.find_first_of(" \t");
   if (q > l)   q = l; 
-  nom = sel.substr(0, q);
-}
+  nom = dirlist->GetValueStr() + '/' + sel.substr(0, q);
+  }
 
 NamedObjMgr* om = dap->ObjMgr();
 if (om == NULL)  return;
-if (nom == "")  return;
+if (nom.length() < 1)  return;
 
 switch (msg)
   {
-  case 100:
+  case 20:
     om->DisplayObj(nom);
     break;
-  case 200:
+  case 30:
     om->PrintObj(nom);
     break;
-  case 300:
-    if (dap->mPpfout)  om->SaveObj(nom, *(dap->mPpfout));
-    break;
-  case 400:
+  case 40:
+    if (dap->mPpfout)  om->SaveObj(nom, *(dap->mPpfout), false);
+    break;
+  case 50:
     om->DelObj(nom);
-    break;
-
-  case 900:
-    dap->SetReady();
-    Hide();
+    objlist->DeleteItemMsg(objlist->GetSelection());
+    //    dap->ObjMgr()->UpdateObjMgrWindow(dirlist->GetValue()-30000);
     break;
 
@@ -218,6 +233,6 @@
   if (ln <= 0)  nom = "?";
   else { strncpy(noms, mPin->TagName(i).c_str(), 31);  noms[31] = '\0'; nom = noms; }
-//  sprintf(strg, "%s  (T=%s, Key=%d)",  nom, dap->ObjMgr()->GetServiceObj()->PClassIdToClassName(cid), key);
-  sprintf(strg, "%s  (T=%s, Key=%d)",  nom, " DataObject ?", key);
+  sprintf(strg, "%s  (T=%s, Key=%d)",  nom, dap->ObjMgr()->GetServiceObj()->PClassIdToClassName(cid), key);
+  //  sprintf(strg, "%s  (T=%s, Key=%d)",  nom, " DataObject ?", key);  Attention SANS_EVOLPLANCK
   objlist->AppendItem(strg, 5000+i);
 }
Index: /trunk/SophyaPI/PIext/pisiadw.h
===================================================================
--- /trunk/SophyaPI/PIext/pisiadw.h	(revision 332)
+++ /trunk/SophyaPI/PIext/pisiadw.h	(revision 333)
@@ -1,2 +1,7 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Classe de fenetre pour gestion d'objet et PPF-In
+// Reza      Aout 97 , Juillet,Aout 98, Ete 99
+// CEA-DAPNIA      LAL-IN2P3/CNRS
+
 #ifndef PISIADW_H_SEEN
 #define PISIADW_H_SEEN
@@ -25,12 +30,18 @@
   virtual void  Show();
   virtual void  Process(PIMessage msg, PIMsgHandler* sender, void* data=NULL);
-  inline void AddObj(const char * objid, PIMessage msg) 
-    { objlist->AppendItem(objid, msg); }
-  inline void DelObj(PIMessage msg) 
-    { objlist->DeleteItemMsg(msg); }
+  inline  void  AddDirectory(const char * dir, int did)
+                    { dirlist->AppendItem(dir, 30000+did); }
+  inline  void  DelDirectory(int did)
+                    { dirlist->Menu()->DeleteItemMsg(30000+did); }
+  inline  void  ClearHelpList() 
+                    { mNitem=0; objlist->DeleteAllItems(); }
+  inline  void	AddObj(const char * objn) 
+		    { mNitem++;  objlist->AppendItem(objn, 100+mNitem); }
 private:
   PIStdImgApp* dap;
+  PIOptMenu* dirlist;
+  int mNitem;
   PIList* objlist;
-  PIButton * mBut[5];
+  PIButton * mBut[6];
 };
 
Index: /trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 333)
@@ -149,5 +149,4 @@
  
 mObjMgr = new NamedObjMgr;
-mObjMgr->SetImgApp(this);
 mCmd = new PIACmd(mObjMgr, this);
 
@@ -161,4 +160,7 @@
 mObjmgrw = new ObjMgrWind(this);
 mPpinmgrw = new PPInMgrWind(this);
+
+// Attention : A faire apres creation de ObjMgrWind !!! 
+mObjMgr->SetImgApp(this);
 
 // Gestion des feneteres widgets et drawers
Index: /trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.cc	(revision 332)
+++ /trunk/SophyaPI/PIext/servnobjm.cc	(revision 333)
@@ -21,4 +21,12 @@
 #include "pistdimgapp.h"
 
+#include "fct1dfit.h"
+#include "fct2dfit.h"
+
+#include "matrix.h"
+#include "cvector.h"
+#include "ntuple.h"
+#include "cimage.h"
+
 #include "histos.h"
 #include "histos2.h"
@@ -28,4 +36,8 @@
 #include "piscdrawwdg.h"
 #include "pisurfdr.h"
+
+#include "pintuple.h"
+#include "pintup3d.h"
+
 #include "pipodrw.h"
 
@@ -33,9 +45,10 @@
 
 /* --Methode-- */
-Services2NObjMgr::Services2NObjMgr(PIStdImgApp* app, string& tmpdir)
+Services2NObjMgr::Services2NObjMgr(NamedObjMgr* omg, string& tmpdir)
 {
 TmpDir = tmpdir;
 PDynLinkMgr::SetTmpDir(tmpdir);
-mImgapp = app;
+mImgapp = NULL;
+mOmg = omg;
 dynlink = NULL;
 InitGrAttNames();
